#!/usr/bin/python
# -*- coding: latin-1 -*-
 
import calendar, string, sys, codecs, datetime, calendarUtils, VCardReader, os.path, os
 
# http://www.salesianer.de/util/kalframe.html
# Diese Seite (mit Mozilla und Javascript besuchen) kennt viele Berechnungen
# ber Kalender. Man kann dort auch Termine von beweglichen Feiertagen
# berechnen lassen.

#-------- Configure this section every year ---------------------------
# if Plain only Numbers, no texts, no colorboxes
#MODE="DINA2" 
MODE="DINA4"
PLAIN=False

if os.environ.get('WK_MODE'):
    if os.environ.get('WK_MODE').find('DINA4') > -1:
        MODE='DINA4'
    elif os.environ.get('WK_MODE').find('DINA2') > -1:
        MODE='DINA2'
        
    PLAIN=(os.environ.get('WK_MODE').find('PLAIN') > -1)

if MODE=="DINA4":
    print "--> Modus: 4 Seite DINA4"
elif MODE=="DINA2":
    print "--> Modus: 1 Seite DINA2"
else:
    print "--> Der Seitenmodus ist unbekannt??????"

print "--> Style PLAIN:", PLAIN

#print several reminders
LUG = False
DLUG = True
FSFE = True


# there is a loop over several year in the end:
Year=2013

# run once make HP with YearLoopIteration=1,
# to create the files for one year in root dir,
# then YearLoopIteration=10,
# to let make create everythin in Out Dir
# just to avoid that latex doesnot find a file and
# thus stopping make
YearLoopIteration= 13


specialFreeDays = {}
specialDays     = calendarUtils.appendYear(Year,{
#                    '6.2'  : 'Vorlesungsende',
#                    '1.4'  : 'Beginn SoSe',
#                    '19.4' : 'Vorlesungsbeginn',
#
#                    '16.7' : 'Vorlesungsende',
#                    '1.10' : 'Beginn WiSe',
#                    '11.10': 'Vorlesungsbeginn',
    })

# Diese Termine werden in den freien Platz eingetragen,
# keine besonderen Formatierungen.

Termine = {}
calendarUtils.appendYear(Year,{
    })


EasternFreeDays = {
        'Karfreitag'          :  -2, 
        'Christi Himmelfahrt' :  39,
        'Pfingstmontag'       :  50,
        'Fronleichnam'        :  60, 
}


EasternNoFreeDays = {
        'Ostersonntag'        :   0,  # ist Sonntag
        'Pfingstsonntag'      :  49,  # ist Sonntag
        'Herz-Jesu-Freitag'   :  68,  # ?Wat dat denn?
        'Rosenmontag'         : -48,
        'Aschermittwoch'      : -46,  
}


AdventDays = {
        '1. Advent'           :   0,
        '2. Advent'           :   7,
        '3. Advent'           :  14,
        '4. Advent'           :  21,
        'Totensonntag'        :  -7,
        'Bu \& Bettag'       : -11,
        'Volkstrauertag'      : -14
}


birthdays = {}
# KAddressbook support is ancient from the file-based era
# someday I have to implement akonade support ...
KAddressbook = None

#KAddressbook = os.path.expanduser('~/.kde/share/apps/kabc/std.vcf')
KAddressbook = os.path.expanduser('~/src/Python/WandKalender/addressbook.vcf')
KAddressbook_Field= 'X-KADDRESSBOOK-WANDKALENDER-NAME'
calendarUtils.appendYear(Year,{
    })

# the VCF Reader uses all uppercase Fieldnames

# set KAddressbook to the std.vcf File from Kaddressbook
#   then Kaddressbook entries with birthdays will be shown.
#   If KAddressbook_Field is present, use this string,
#   else use the N_GivenName Field
# or
# set KAddressbook to False,
#   then you can add birthdays by hand in the birthdays dictionary:

#birthdays = calendarUtils.appendYear(Year,{
#   '4.5': 'Lars Fischer'
#})


# anonymisieren fr die Homepage-Version:
if (os.environ.get('ANON') != None ):
    print "--> Style ANON:", True
    LUG = False
    DLUG= False
    FSFE= False
    KAddressbook = False
    birthdays={}
    Termine={}

#--------- Nothing to change beneath this line ---------------------------

#OsterSonntag = calendarUtils.calcEastern(Year)
from calendarUtils import *
import config
config.configureForYear(Year)
import time


def initBirthdaysFromKAddressbook(ABFilename):
    """Read the vcf-File ABFilename, which is the Data
    File from kaddressbook.

    Entries with a birthday are shown in the calendar.
    The Field N_GivenName is used. But if an entry has a field with the
    value of KAddressbook_Field, then that field is used.

    (For example to abbrevate lang names, to add LaTeX Markup (\small ... )
    or to use another name like Tante, Onkel XY .) 
    """
    b = {} 

    VC = VCardReader.VCFCollection(ABFilename)
    print "Reading Birthdays from", ABFilename

    for c in VC.Contacts:
        if c.has_key('BDAY'):
            print c.__str__().encode('latin-1')
            bd = c['BDAY']
            t = bd[0].split('-')
            tm = str(int(t[1])) # strip leading zero
            td = str(int(t[2][:2])) 

            bKey = td+'.'+tm+'.'+str(Year)
            if c.has_key(KAddressbook_Field):
                bName = c[KAddressbook_Field][0].encode('latin-1')
            else:
                bName = c['N_GivenName'].encode('latin-1') #+ ' ' + c['N_FamilyName'].encode('latin-1')

            if b.has_key(bKey):
                b[bKey] = b[bKey]+'/'+ bName
            else:
                b[bKey] = bName

    #for bk in b.keys():
    #    print bk, b[bk]
    return b
# of initBirthdaysFromKAddressbook()


def printHeaderRow(offset):
    if MODE=="DINA2":
        till= 12
    elif MODE=="DINA4":
        till= offset+6
        
    content = ''
    for m in range(offset, till):
        content = content +'{\\textbf{\Large '+config.HeaderHeight+config.Months[m][0]+'}} '
        if m < till-1:
            content = content + '&'
            
    print content , ' \\\\ \\hline \\hline'
# of printHeaderRow())


def makeColorBox(text=None):
    # if text is in size tiny, we select a smaller height
    if text and text.find(r'\tiny')>-1:
        height = '\\rule{0pt}{4pt}'
    else:
        height = '\\rule{0pt}{8pt}'

    if text:
        col = 'BirthdayColor'
        text = '\\makebox[\\widthof{'+text+'}]{}'+height
    else:
        col = 'FreeColor'
        text= '\\rule{1.1cm}{0pt}'+height

    return '\\colorbox{'+col+'}{'+text+'}'
#of makeColorBox()


def makeTableForCell(d,m):
    Text1 = ''
    Text2 = ''
    Text3 = ''
    Text4 = ''
    dayStr = str(d)+'.'+str(m)+'.'+str(Year)
    BirthdayBox = ''
    ColorBox = makeColorBox()
    colorize = False
    
    valid = (d <= config.Months[m-1][1])
    
    if valid:
        weekDay = config.Days[calendar.weekday(Year,m,d)]
        dayNumber = str(d)
        if d < 10:
            dayNumber = '\\hspace{1.3ex}'+dayNumber
            
        if not PLAIN:
            text = dayNumber+' '+weekDay
            if weekDay =='So':
                text = '\\textbf{'+text+'}'
        else:
            text = dayNumber
            
        Text1 +=  text

        # colorize Sundays and free days
        if ((weekDay in ['So']) or specialFreeDays.has_key(dayStr)) and not PLAIN: 
            colorize = True

        # mark birthdays with a different color
        if birthdays.has_key(dayStr):
            if len(birthdays[dayStr]) > 16:
                birthdays[dayStr] = "\\tiny{"+birthdays[dayStr]+"}"
            Text2 = '\\textbf{'+birthdays[dayStr]+'}'
            BirthdayBox = makeColorBox(Text2)

        # Label for the special days
        if specialFreeDays.has_key(dayStr):
            Text3 = '\\tiny{'+specialFreeDays[dayStr]+'}'
        elif specialDays.has_key(dayStr):
            Text3 = '\\tiny{'+specialDays[dayStr]+'}'

        if Termine.has_key(dayStr):
            Text2 += Termine[dayStr]

    # -------------------------------------------------------------------
        # Kalenderwochennummer anbringen:
        if ((weekDay == 'Mo') or ((d == 1) and (m==1))) and not PLAIN:
            Text4 = '\\tiny{KW: '+str(calcCalWeek(datetime.date(Year,m,d)))+'}'

        l = calendar.monthrange(Year,m)
        if (weekDay == 'Mo') and (LUG):
            if d+7 > l[1]:
                Text4 += '\\quad \\tiny{\\textbf{LUG-MK: 19:00}}'
        if (weekDay == 'Do') and (DLUG):
            if d+7 > l[1]:
                Text4 += '\\quad \\tiny{\\textbf{DLUG: 19:30}}'
        if (weekDay == 'Mi') and (FSFE):
            if d+7 > l[1]:
                Text4 += '\\quad \\tiny{\\textbf{FSFE: 19:30}}'
    # of if valid

    cell = '    \\begin{picture}(100,29)(0,-9)'
    if colorize:
        cell += '''
      \\put(-2,8){'''+ColorBox+'}'
    if BirthdayBox != '':
        cell+='\\put(35,8.3){' + BirthdayBox + '}'
    cell+='''
      \\put(0,8.3){'''  + Text1 + '''}
      \\put(38,8.3){''' + Text2 + '''}
      \\put(-3,-2){''' + Text3 + '''}
      \\put(-3,-9){'''+ Text4 + '''}
    \\end{picture}'''

#Layout:
# T1 T2
#  T3
#  T4

    if MODE=="DINA2":
        if m < 12:
            cell += '&'
    elif MODE=="DINA4":
        if (m % 6) !=0 :
            cell += '&'
        

    # now it is time for writing the Text in the LaTeX document
    print  cell
# of makeTableForCell())



def writeLaTeX_FileDINA2():
    if PLAIN: p='-PLAIN'
    else:
        p=''
    
    f = open(AddDir + 'Kalender-DINA2'+p+'.tex','w')
    # change  stdout to file f
    sys.stdout = f
    
    print config.LaTeXProlog%(str(Year),'a2paper,landscape,margin=2cm,top=1cm,left=1cm') 
    print config.LaTeXTableProlog%'12'
    printHeaderRow(0)
    for d in range(31):
        for m in range(12):
            makeTableForCell(d+1,m+1)
        print '\\\\ \\hline'
    print config.LaTeXTableEpilog
            
        #if (o == 0): #21.4cm
    # Disclaimer: ABSOLUTE no WARRANTY, -- YOU have to check if the dates are correct for your country for every new year
    print ' \\rule{0pt}{1cm}\\rule{0.3cm}{0pt}{'+config.footer1%(str(Year),'21.1cm')+'\\hspace{0.8cm} }'+ \
          '\\raisebox{1ex}{  \\,\\,'+config.footer2%'17.2cm'+'\\rule{0pt}{0.5cm}}' 
            
    print config.LaTeXEpilog
    # restore sdtout
    #sys.stdout = sys.__stdout__
    f.close()
#of writeLaTeX_FileDINA2()


def writeLaTeX_FileDINA4():
    
    def printDayRow(d,offset):
        for m in range(offset,offset + 6):
            makeTableForCell(d,m+1)
        print '\\\\ \\hline'
    #of printdayRow()

    # configure stdout to support latin-1 encoded characters
    # sys.stdout = codecs.lookup('latin-1')[-1](sys.stdout)
    if PLAIN: p='-PLAIN'
    else:
        p=''
    
    f = open(AddDir + 'Kalender-DINA4'+p+'.tex','w')
    # change  stdout to file f
    sys.stdout = f
    
    print config.LaTeXProlog%(str(Year),'a4paper,margin=2pt,top=0.5cm,landscape') 
    for o in [0,6]:
        print config.LaTeXTableProlog%'6'
        printHeaderRow(o)
        for d in range(15):
            printDayRow(d+1,o)
        print config.LaTeXTableEpilog
        print '\n \\newpage \n'
    
        print config.LaTeXTableProlog%'6'
        for d in range(15,31):
            printDayRow(d+1,o)
        print config.LaTeXTableEpilog
            
        if (o == 0):
            print '\\\\ \\rule{0pt}{1cm}\\rule{0.3cm}{0pt}'+config.footer1%(str(Year),'21.4cm')+'\\newpage'
            
    # Disclaimer: ABSOLUTE no WARRANTY, -- YOU have to check if the dates are correct for your country for every new year
    print '\\\\ \\rule{0.8cm}{0pt}\\raisebox{-5ex}{'+config.footer2%('15.2cm')+'}'
    print config.LaTeXEpilog
    # restore sdtout
    f.close()
#of writeLaTeX_FileDINA4()


def workForYear( ):
   sys.stdout = codecs.lookup('latin-1')[-1](sys.stdout)
 
   if MODE=='DINA2':
        writeLaTeX_FileDINA2()
   elif MODE=='DINA4':
        writeLaTeX_FileDINA4()

   sys.stdout = sys.__stdout__
# end of workForYear()
    



if __name__=='__main__':
    import locale
    #locale.setlocale(locale.LC_ALL, 'de_DE.UTF-8') # use German locale; name might vary with platform
    # add de_DE.UTF-8 to /var/lib/locales/supported.d/local
    # run update-locale
    # add LANG="de_DE.UTF-8" to /etc/environment
    # logout and login


    # Spezielle Tage
    specialDays.update( {
        '6.1'  : 'Heilige 3 Knige',
        '14.2' : 'Valentinstag',
        '27.6' : 'Siebenschlfer',
        '31.10': 'Reformationstag',
        
        '20.3' : 'Frhlingsanfang',
        '25.5' : 'Towel Day',
                 # www.towelday.org
                 # Towel Day - Celebrating the life and work of Douglas Adams
        
        '21.6' : 'Sommeranfang',
        '23.9' : 'Herbstanfang',
        '21.12': 'Winteranfang',
        
        '24.12': 'Heiligabend',
        '31.12': 'Silvester', 
    } )

    addToList(specialDays, NthWeekDayInMonthAsString(Year,  3, -1, 'Su'),
              '\\tiny{Beginn Sommerzeit}')
    addToList(specialDays, NthWeekDayInMonthAsString(Year, 10, -1, 'Su'),
              '\\tiny{Beginn Winterzeit}')
    addToList(specialDays, NthWeekDayInMonthAsString(Year, 10,  1, 'Su'),
              '\\tiny{Erntedank}')
    addToList(specialDays, NthWeekDayInMonthAsString(Year, 5, 2, 'Su'),
                           '\\tiny{Muttertag}' )
    
    # Days that are no working days:
    specialFreeDays.update( {
                        '1.1'  : 'Neujahr',
                        '1.5'  : 'Maifeiertag',
                        '3.10' : 'Tag d. dt. Einheit',
                        '1.11' : 'Allerheiligen',
                        '25.12': '1. Weihnachtstag',
                        '26.12': '2. Weihnachtstag',
        } )

    # configure stdout to support latin-1 encoded characters
    #for y in [ Year ]
    for y in range(Year, Year + YearLoopIteration ):
        # when creating many Year in one go:
        Year = y
        if YearLoopIteration > 1:
            AddDir = 'Out/'+str(Year)+'_'
        else:      
            AddDir = ''
 
        print y, AddDir

        config.configureForYear( y )
        # days depending on the Eastern date:
        # look in calendarUtils for the calculation of Eastern!
        Eastern= calcEastern(Year)
        updateDicByOffset( specialFreeDays,
                           Eastern, EasternFreeDays )
        updateDicByOffset( specialDays,
                           Eastern, EasternNoFreeDays )
        
        updateDicByOffset( specialDays,
                           calcAdventTheFirst( Year ), AdventDays )
        
        if PLAIN:
            specialDays = {}
            specialFreeDays = {}
            Termine = {}
            
            
     
        specialFreeDays = appendYear(Year, specialFreeDays)
        specialDays     = appendYear(Year, specialDays)
     
        
        if KAddressbook:
            birthdays = initBirthdaysFromKAddressbook(KAddressbook)
            #print birthdays
            
        workForYear( )

    
