# -*- coding: latin-1 -*-
import calendar
import calendarUtils


Days = ['Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa', 'So']

# call configureForYear() for these to be set
Months=[] 


#--------- configure the LaTeX things below, once to fit your needs ---------------------------
# the two %s will be replaced by Year via the % Operator
LaTeXProlog = """\\documentclass{article}
  \\usepackage[ngerman]{babel}
  \\usepackage[latin1]{inputenc}
  \\usepackage[T1]{fontenc}

  \\usepackage{times}
  \\usepackage[pdftex]{graphicx,color}
  \\usepackage[pdfauthor={Lars Fischer},pdftitle={Wandkalender %s}]{hyperref}
  \\hypersetup{colorlinks=false}
  \\pdfcompresslevel=9

  \usepackage[%s]{geometry}
  \\usepackage{calc} 
  
\\begin{document}
  \\setlength{\\unitlength}{1pt}
  \pagestyle{empty}
  %% if you can print in colour, choose some nice colours here
  \\definecolor{FreeColor}{gray}{0.9}
  \\definecolor{BirthdayColor}{gray}{0.7}
"""

LaTeXTableProlog = """
  \\begin{tabular}{|*{%s}{p{4.27cm}|}}
    \\hline"""

LaTeXTableEpilog = """\\end{tabular}"""

LaTeXEpilog = """
\\end{document}
"""

HeaderHeight = '\\rule[-0.5cm]{0pt}{1.1cm}'


footer1 = '{\\Huge \\,\\,%s\\hspace{%s} Lars Fischer}' # %s will be replaced by Year via % operator                
footer2 = 'http://www.larsfischer.de.vu \\hspace{%s} keine Gewhr fr die Richtigkeit der Angaben' # 0.5cm



def configureForYear(y):
    global Months
    global footer1
    global LaTeXProlog

    d = 28
    if calendar.isleap(y):
        d = 29
    #change Strings for different languages
    Months = [ ['Januar'    , 31],
               ['Februar'   , d],
               ['Mrz'      , 31],
               ['April'     , 30],
               ['Mai'       , 31],
               ['Juni'      , 30],
               ['Juli'      , 31],
               ['August'    , 31],
               ['September' , 30],
               ['Oktober'   , 31],
               ['November'  , 30],
               ['Dezember'  , 31]  ]

    


